/****************************************************************************

  Geekamp source code, based originally on GeekMASTER's GEEKAmp.dll source (1.4).
  
	Check changes.txt for updates. 
	
	Code written by Ben Crosse, Azathoth (azathoth@ls2k.org).
	Updates found at http://azathoth.ls2k.org/ and at the regular news sites (litestep.net, ls2k, modulo, fpn)
	  
	Released under the GPL. Read that document for info. 
		
****************************************************************************/

#include "geekamp.h"
const char szAppName[] = "Geekamp"; // Our window class, etc
const char rcsRevision[] = "$Revision: 1.9.666"; // Our Version
const char rcsId[] = "$Id: geekamp.cpp,v 1.9.666 14:41:57 Azathoth Exp $"; // The Full RCS ID.
Geekamp *geekamp; // The module


//=========================================================
// Initialization and cleanup
//=========================================================
int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath) {
	int code;
	Window::init(dllInst);
	geekamp = new Geekamp(ParentWnd, code);
	return code;
}

void quitModule(HINSTANCE dllInst) {
	delete geekamp;
}


//=========================================================
// Bang commands
//=========================================================
void BangAmp_AboutFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_About();
}


void BangAmp_DoubleSizeFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_DoubleSize();
}


void BangAmp_EasyMoveFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_EasyMove();
}


void BangAmp_EditID3Function(HWND caller, LPCSTR args) {
	geekamp->BangAmp_EditID3();
}


void BangAmp_EqFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Eq();
}


void BangAmp_Ffwd5sFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Ffwd5s();
}


void BangAmp_Jump10BackFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Jump10Back();
}


void BangAmp_Jump10FwdFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Jump10Fwd();
}


void BangAmp_JumpToFileFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_JumpToFile();
}


void BangAmp_JumpToTimeFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_JumpToTime();
}


void BangAmp_ListEndFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_ListEnd();
}


void BangAmp_ListStartFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_ListStart();
}


void BangAmp_LoadDirFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_LoadDir();
}


void BangAmp_LoadFileFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_LoadFile();
}


void BangAmp_MainMenuPopupFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_MainMenuPopup();
}


void BangAmp_NextFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Next();
}


void BangAmp_OnTopFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_OnTop();
}


void BangAmp_OpenLocFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_OpenLoc();
}


void BangAmp_PauseFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Pause();
}


void BangAmp_PlayFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Play();
}


void BangAmp_PlaylistFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Playlist();
}


void BangAmp_PowerFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Power();
}


void BangAmp_PrefsFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Prefs();
}


void BangAmp_PrevFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Prev();
}


void BangAmp_ReloadSkinFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_ReloadSkin();
}


void BangAmp_RepeatFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Repeat();
}


void BangAmp_Rewd5sFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Rewd5s();
}


void BangAmp_SelectSkinFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_SelectSkin();
}


void BangAmp_SetPanningFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_SetPanning(args);
}


void BangAmp_SetVolumeFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_SetVolume(args);
}


void BangAmp_ShadeBothFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_ShadeBoth();
}


void BangAmp_ShadePlaylistFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_ShadePlaylist();
}


void BangAmp_ShowFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Show();
}


void BangAmp_ShuffleFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Shuffle();
}


void BangAmp_StartPluginFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_StartPlugin();
}


void BangAmp_StopFadeFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_StopFade();
}


void BangAmp_StopPluginFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_StopPlugin();
}


void BangAmp_ToggleBrowserFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_ToggleBrowser();
}


void BangAmp_VisSetupFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_VisSetup();
}


void BangAmp_VolumeDownFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_VolumeDown();
}


void BangAmp_VolumeUpFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_VolumeUp();
}


void BangAmp_WindowShadeFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_WindowShade();
}

void BangAmp_StopFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Stop();
}

void BangAmp_RewFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Rew();
}

void BangAmp_HighPriorityFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_HighPriority();
}

void BangAmp_FileInfoFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_FileInfo();
}

void BangAmp_PowerOnFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_PowerOn();
}

void BangAmp_PowerOffFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_PowerOff();
}

void BangAmp_Ffwd10sFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Ffwd10s();
}

void BangAmp_Ffwd20sFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Ffwd20s();
}

void BangAmp_Rew10sFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Rew10s();
}

void BangAmp_Rew20sFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Rew20s();
}

void BangAmp_RestartFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Restart();
}

void BangAmp_MovePositionFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_MovePosition(args);
}

void BangAmp_LoadEQPresetFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_LoadEQPreset();
}

void BangAmp_PlayPauseFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_PlayPause();
}

void BangAmp_HideFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Hide();
}

void BangAmp_DisplayFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_Display();
}

void BangAmp_AddSongFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_AddSong(args);
}

void BangAmp_TimeRemainingFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_TimeRemaining();
}

void BangAmp_TimeElapsedFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_TimeElapsed();
}

void BangAmp_LS2KFunction(HWND caller, LPCSTR args) {
	geekamp->BangAmp_LS2K();
}

//=========================================================
// Module code
//=========================================================

//---------------------------------------------------------
// Module constructor
//---------------------------------------------------------
Geekamp::Geekamp(HWND parentWnd, int& code):
Window(szAppName)
{
	int msgs[] = {LM_GETREVID, 0};
	
	if (!createWindow(WS_EX_TOOLWINDOW, szAppName, WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
		0, 0, 0, 0, parentWnd))
	{
		MessageBox(NULL, "Unable to create window.", szAppName, MB_TOPMOST);
		code = 1;
		return;
	}
	
	SetWindowLong(hWnd, GWL_USERDATA, magicDWord);
	
	WinampStartNormal = GetRCBoolDef("WinampStartNormal", FALSE);
	PlayNotOpen = GetRCBoolDef("PlayNotOpen", FALSE);
	PlayPauseNotOpen = GetRCBoolDef("PlayPauseNotOpen", FALSE);
	PlaylistNotOpen = GetRCBoolDef("PlaylistNotOpen", FALSE);
	PrefsNotOpen = GetRCBoolDef("PrefsNotOpen", FALSE);
	LoadFileNotOpen = GetRCBoolDef("LoadFileNotOpen", FALSE);
	ShowNotOpen = GetRCBoolDef("ShowNotOpen", FALSE);
	GetRCString("WinampPath", szAmpPath, "c:\\progra~1\\winamp\\winamp.exe", MAX_LINE_LENGTH);
	
	SendMessage(hParent, LM_REGISTERMESSAGE, (WPARAM)hWnd, (LPARAM)msgs);
	AddBangCommand("!Amp_AddSong",BangAmp_AddSongFunction);
	AddBangCommand("!Amp_LoadEQPreset",BangAmp_LoadEQPresetFunction);
	AddBangCommand("!Amp_FileInfo",BangAmp_FileInfoFunction);
	AddBangCommand("!Amp_HighPriority",BangAmp_HighPriorityFunction);
	AddBangCommand("!Amp_About",BangAmp_AboutFunction);
	AddBangCommand("!Amp_DoubleSize",BangAmp_DoubleSizeFunction);
	AddBangCommand("!Amp_EasyMove",BangAmp_EasyMoveFunction);
	AddBangCommand("!Amp_EditID3",BangAmp_EditID3Function);
	AddBangCommand("!Amp_Eq",BangAmp_EqFunction);
	AddBangCommand("!Amp_Ffwd5s",BangAmp_Ffwd5sFunction);
	AddBangCommand("!Amp_Jump10Back",BangAmp_Jump10BackFunction);
	AddBangCommand("!Amp_Jump10Fwd",BangAmp_Jump10FwdFunction);
	AddBangCommand("!Amp_JumpToFile",BangAmp_JumpToFileFunction);
	AddBangCommand("!Amp_JumpToTime",BangAmp_JumpToTimeFunction);
	AddBangCommand("!Amp_ListEnd",BangAmp_ListEndFunction);
	AddBangCommand("!Amp_ListStart",BangAmp_ListStartFunction);
	AddBangCommand("!Amp_LoadDir",BangAmp_LoadDirFunction);
	AddBangCommand("!Amp_LoadFile",BangAmp_LoadFileFunction);
	AddBangCommand("!Amp_MainMenuPopup",BangAmp_MainMenuPopupFunction);
	AddBangCommand("!Amp_Next",BangAmp_NextFunction);
	AddBangCommand("!Amp_OnTop",BangAmp_OnTopFunction);
	AddBangCommand("!Amp_OpenLoc",BangAmp_OpenLocFunction);
	AddBangCommand("!Amp_Pause",BangAmp_PauseFunction);
	AddBangCommand("!Amp_Play",BangAmp_PlayFunction);
	AddBangCommand("!Amp_Playlist",BangAmp_PlaylistFunction);
	AddBangCommand("!Amp_Power",BangAmp_PowerFunction);
	AddBangCommand("!Amp_Prefs",BangAmp_PrefsFunction);
	AddBangCommand("!Amp_Prev",BangAmp_PrevFunction);
	AddBangCommand("!Amp_ReloadSkin",BangAmp_ReloadSkinFunction);
	AddBangCommand("!Amp_Repeat",BangAmp_RepeatFunction);
	AddBangCommand("!Amp_Rewd5s",BangAmp_Rewd5sFunction);
	AddBangCommand("!Amp_SelectSkin",BangAmp_SelectSkinFunction);
	AddBangCommand("!Amp_SetPanning",BangAmp_SetPanningFunction);
	AddBangCommand("!Amp_SetVolume",BangAmp_SetVolumeFunction);
	AddBangCommand("!Amp_ShadeBoth",BangAmp_ShadeBothFunction);
	AddBangCommand("!Amp_ShadePlaylist",BangAmp_ShadePlaylistFunction);
	AddBangCommand("!Amp_Show",BangAmp_ShowFunction);
	AddBangCommand("!Amp_Shuffle",BangAmp_ShuffleFunction);
	AddBangCommand("!Amp_StartPlugin",BangAmp_StartPluginFunction);
	AddBangCommand("!Amp_StopFade",BangAmp_StopFadeFunction);
	AddBangCommand("!Amp_StopPlugin",BangAmp_StopPluginFunction);
	AddBangCommand("!Amp_ToggleBrowser",BangAmp_ToggleBrowserFunction);
	AddBangCommand("!Amp_VisSetup",BangAmp_VisSetupFunction);
	AddBangCommand("!Amp_VolumeDown",BangAmp_VolumeDownFunction);
	AddBangCommand("!Amp_VolumeUp",BangAmp_VolumeUpFunction);
	AddBangCommand("!Amp_WindowShade",BangAmp_WindowShadeFunction);
	AddBangCommand("!Amp_Stop",BangAmp_StopFunction);
	AddBangCommand("!Amp_Rew",BangAmp_RewFunction);
	AddBangCommand("!Amp_PowerOn",BangAmp_PowerOnFunction);
	AddBangCommand("!Amp_PowerOff",BangAmp_PowerOffFunction);
	AddBangCommand("!Amp_Ffwd10s",BangAmp_Ffwd10sFunction);
	AddBangCommand("!Amp_Ffwd20s",BangAmp_Ffwd20sFunction);
	AddBangCommand("!Amp_Rewd10s",BangAmp_Rew10sFunction);
	AddBangCommand("!Amp_Rewd20s",BangAmp_Rew20sFunction);
	AddBangCommand("!Amp_Restart",BangAmp_RestartFunction);
	AddBangCommand("!Amp_MovePosition",BangAmp_MovePositionFunction);
	AddBangCommand("!Amp_PlayPause",BangAmp_PlayPauseFunction);
	AddBangCommand("!Amp_Hide",BangAmp_HideFunction);
	AddBangCommand("!Amp_Display",BangAmp_DisplayFunction);
	AddBangCommand("!Amp_TimeRemaining", BangAmp_TimeRemainingFunction);
	AddBangCommand("!Amp_TimeElapsed", BangAmp_TimeElapsedFunction);
	AddBangCommand("!Amp_LS2k", BangAmp_LS2KFunction);
	code = 0;
}

//---------------------------------------------------------
// Module destructor
//---------------------------------------------------------
Geekamp::~Geekamp()
{
	int msgs[] = {LM_GETREVID, 0};
	
	SendMessage(hParent, LM_UNREGISTERMESSAGE, (WPARAM)hWnd, (LPARAM)msgs);
	RemoveBangCommand("!Amp_TimeRemaining");
	RemoveBangCommand("!Amp_PlayPause");
	RemoveBangCommand("!Amp_LoadEQPreset");
	RemoveBangCommand("!Amp_Rewd20s");
	RemoveBangCommand("!Amp_Rewd10s");
	RemoveBangCommand("!Amp_Ffwd20s");
	RemoveBangCommand("!Amp_Ffwd10s");
	RemoveBangCommand("!Amp_FileInfo");
	RemoveBangCommand("!Amp_HighPriority");
	RemoveBangCommand("!Amp_About");
	RemoveBangCommand("!Amp_DoubleSize");
	RemoveBangCommand("!Amp_EasyMove");
	RemoveBangCommand("!Amp_EditID3");
	RemoveBangCommand("!Amp_Eq");
	RemoveBangCommand("!Amp_Ffwd5s");
	RemoveBangCommand("!Amp_Jump10Back");
	RemoveBangCommand("!Amp_Jump10Fwd");
	RemoveBangCommand("!Amp_JumpToFile");
	RemoveBangCommand("!Amp_JumpToTime");
	RemoveBangCommand("!Amp_ListEnd");
	RemoveBangCommand("!Amp_ListStart");
	RemoveBangCommand("!Amp_LoadDir");
	RemoveBangCommand("!Amp_LoadFile");
	RemoveBangCommand("!Amp_MainMenuPopup");
	RemoveBangCommand("!Amp_Next");
	RemoveBangCommand("!Amp_OnTop");
	RemoveBangCommand("!Amp_OpenLoc");
	RemoveBangCommand("!Amp_Pause");
	RemoveBangCommand("!Amp_Play");
	RemoveBangCommand("!Amp_Playlist");
	RemoveBangCommand("!Amp_Power");
	RemoveBangCommand("!Amp_Prefs");
	RemoveBangCommand("!Amp_Prev");
	RemoveBangCommand("!Amp_ReloadSkin");
	RemoveBangCommand("!Amp_Repeat");
	RemoveBangCommand("!Amp_Rew");
	RemoveBangCommand("!Amp_Rewd5s");
	RemoveBangCommand("!Amp_SelectSkin");
	RemoveBangCommand("!Amp_SetPanning");
	RemoveBangCommand("!Amp_SetVolume");
	RemoveBangCommand("!Amp_ShadeBoth");
	RemoveBangCommand("!Amp_ShadePlaylist");
	RemoveBangCommand("!Amp_Show");
	RemoveBangCommand("!Amp_Shuffle");
	RemoveBangCommand("!Amp_StartPlugin");
	RemoveBangCommand("!Amp_StopFade");
	RemoveBangCommand("!Amp_StopPlugin");
	RemoveBangCommand("!Amp_ToggleBrowser");
	RemoveBangCommand("!Amp_VisSetup");
	RemoveBangCommand("!Amp_VolumeDown");
	RemoveBangCommand("!Amp_VolumeUp");
	RemoveBangCommand("!Amp_WindowShade");
	RemoveBangCommand("!Amp_Stop");
	RemoveBangCommand("!Amp_PowerOn");
	RemoveBangCommand("!Amp_PowerOff");
	RemoveBangCommand("!Amp_MovePosition");
	RemoveBangCommand("!Amp_Restart");
	RemoveBangCommand("!Amp_Hide");
	RemoveBangCommand("!Amp_Display");
	RemoveBangCommand("!Amp_AddSong");
	RemoveBangCommand("!Amp_TimeElapsed");
	RemoveBangCommand("!Amp_LS2k");
	destroyWindow();
}

//=========================================================
// Registered messages
//=========================================================

void Geekamp::windowProc(Message& message)
{
	BEGIN_MESSAGEPROC
		MESSAGE(onEndSession,        WM_ENDSESSION)
		MESSAGE(onEndSession,        WM_QUERYENDSESSION)
		MESSAGE(onGetRevId,          LM_GETREVID)
		MESSAGE(onSysCommand,        WM_SYSCOMMAND)
		END_MESSAGEPROC
}

//=========================================================
// Message handlers
//=========================================================
void Geekamp::onEndSession(Message& message)
{
	message.lResult = SendMessage(hParent, message.uMsg, message.wParam, message.lParam);
}

void Geekamp::onGetRevId(Message& message)
{
	char* buf = (char*)(message.lParam);
	
	switch (message.wParam)
	{
	case 0:
		sprintf(buf, "Geekamp %s (Azathoth) ", &rcsRevision[11]);
		buf[strlen(buf) - 1] = '\0';
		break;
	case 1:
		strcpy(buf, &rcsId[1]);
		buf[strlen(buf) - 1] = '\0';
		break;
	default:
		strcpy(buf, "");
	}
	message.lResult = strlen(buf);
}

void Geekamp::onSysCommand(Message& message)
{
	if (message.wParam == SC_CLOSE)
		PostMessage(hParent, WM_KEYDOWN, LM_SHUTDOWN, 0);
	else
		message.lResult = DefWindowProc(hWnd, message.uMsg, message.wParam, message.lParam);
}

//=========================================================
// Bang command handling
//=========================================================
void Geekamp::BangAmp_TimeElapsed() {
	WinampMessage(WINAMP_OPTIONS_ELAPSED);
}
void Geekamp::BangAmp_TimeRemaining() {
	WinampMessage(WINAMP_OPTIONS_REMAINING);
}

void Geekamp::BangAmp_AddSong(LPCSTR args) {
	char addSong[MAX_LINE_LENGTH];
	strcat(addSong, szAmpPath);
	strcat(addSong, " /ADD ");
	strcat(addSong, args);
	WinExec(addSong, SW_NORMAL);
	strcpy(addSong, "");
}

void Geekamp::BangAmp_Hide() {
	PostMessage(GetWinampWnd(), WM_SYSCOMMAND, SC_MINIMIZE, 0);
}

void Geekamp::BangAmp_Display() {
	PostMessage(GetWinampWnd(), WM_SYSCOMMAND, SC_RESTORE, 0);
}

void Geekamp::BangAmp_About() {
	SetForegroundWindow(GetWinampWnd()); // You have to push the window forward before sending messages to keep it on top.
	WinampMessage(WINAMP_HELP_ABOUT);
}

void Geekamp::BangAmp_DoubleSize() {
	WinampMessage(WINAMP_OPTIONS_DSIZE);
}

void Geekamp::BangAmp_EasyMove() {
	WinampMessage(WINAMP_OPTIONS_EASYMOVE);
}

void Geekamp::BangAmp_EditID3() {
	SetForegroundWindow(GetWinampWnd());
	WinampMessage(WINAMP_EDIT_ID3);
}

void Geekamp::BangAmp_Eq() {
	WinampMessage(WINAMP_OPTIONS_EQ);
}

void Geekamp::BangAmp_Ffwd5s() {
	WinampMessage(WINAMP_FFWD5S);
}

void Geekamp::BangAmp_Jump10Back() {
	WinampMessage(WINAMP_JUMP10BACK);
}

void Geekamp::BangAmp_Jump10Fwd() {
	WinampMessage(WINAMP_JUMP10FWD);
}

void Geekamp::BangAmp_JumpToFile() {
	SetForegroundWindow(GetWinampWnd());
	WinampMessage(WINAMP_JUMPFILE);
}

void Geekamp::BangAmp_JumpToTime() {
	SetForegroundWindow(GetWinampWnd());
	WinampMessage(WINAMP_JUMPTIME);
}

void Geekamp::BangAmp_ListEnd() {
	WinampMessage(WINAMP_LIST_END);
}


void Geekamp::BangAmp_ListStart() {
	WinampMessage(WINAMP_LIST_START);
}

void Geekamp::BangAmp_LoadDir() {
	SetForegroundWindow(GetWinampWnd());
	WinampMessage(WINAMP_FILE_DIR);
}

void Geekamp::BangAmp_LoadFile() {
	if (!LoadFileNotOpen) { // Check for bool option
		if (!GetWinampWnd()) // Check to see if winamp is already there
			WinampOpen();
	}
	SetForegroundWindow(GetWinampWnd());
	WinampMessage(WINAMP_FILE_PLAY); 
}

void Geekamp::BangAmp_MainMenuPopup() {
	WinampMessage(WINAMP_MAINMENU);
}

void Geekamp::BangAmp_Next() {
	WinampMessage(WINAMP_NEXTSONG);
}

void Geekamp::BangAmp_OnTop() {
	WinampMessage(WINAMP_OPTIONS_AOT);
}

void Geekamp::BangAmp_OpenLoc() {
	WinampMessage(WINAMP_OPEN_LOC);
}

void Geekamp::BangAmp_Pause() {
	WinampMessage(WINAMP_PAUSE);
}

void Geekamp::BangAmp_Play() {
	if (!PlayNotOpen) {
		if (!GetWinampWnd())
			WinampOpen();
	}
	WinampMessage(WINAMP_PLAY);
}

void Geekamp::BangAmp_Playlist() {
	if (!PlaylistNotOpen) {
		if (!GetWinampWnd())
			WinampOpen();
	}
	WinampMessage(WINAMP_OPTIONS_PLEDIT);
}

void Geekamp::BangAmp_Power() {
	(!GetWinampWnd()) ? WinampOpen() : WinampMessage(WINAMP_FILE_QUIT);
}

void Geekamp::BangAmp_Prefs() {
	if (!PrefsNotOpen) {
		if (!GetWinampWnd())
			WinampOpen();
	}
	WinampMessage(WINAMP_OPTIONS_PREFS);
}

void Geekamp::BangAmp_Prev() {
	WinampMessage(WINAMP_PREVSONG);
}

void Geekamp::BangAmp_ReloadSkin() {
	WinampMessage(WINAMP_RELOAD_SKIN);
}

void Geekamp::BangAmp_Repeat() {
	WinampMessage(WINAMP_FILE_REPEAT);
}

void Geekamp::BangAmp_Rewd5s() {
	WinampMessage(WINAMP_REW5S);
}

void Geekamp::BangAmp_SelectSkin() {
	SetForegroundWindow(GetWinampWnd());
	WinampMessage(WINAMP_OPTIONS_SKINS);
}

void Geekamp::BangAmp_SetPanning(LPCSTR args) {
	SendMessage(GetWinampWnd(), WM_USER, (const int)args, WINAMP_USER_SETPANNING);  // Args = 0 - 255, 0 = all_left, 255 = all_right
}

void Geekamp::BangAmp_SetVolume(LPCSTR args) {
	SendMessage(GetWinampWnd(), WM_USER, (const int)args, WINAMP_USER_SETVOLUME); 
}

void Geekamp::BangAmp_ShadeBoth() {
	WinampMessage(WINAMP_PLAYLIST_WINDOWSHADE);
	WinampMessage(WINAMP_OPTIONS_WINDOWSHADE);
}

void Geekamp::BangAmp_ShadePlaylist() {
	WinampMessage(WINAMP_PLAYLIST_WINDOWSHADE);
}

// checks to see if winamp is minimized, if it is it restores it, if its not it minimizes it
void Geekamp::BangAmp_Show() {
	if (!ShowNotOpen) {
		if (!GetWinampWnd())
			WinampOpen();
	}
	if (!IsIconic(GetWinampWnd()))
		PostMessage(GetWinampWnd(), WM_SYSCOMMAND, SC_MINIMIZE, 0);
	else {
		PostMessage(GetWinampWnd(), WM_SYSCOMMAND, SC_RESTORE, 0);
		SetForegroundWindow(GetWinampWnd());
	}
}

void Geekamp::BangAmp_Shuffle() {
	WinampMessage(WINAMP_FILE_SHUFFLE);
}

void Geekamp::BangAmp_StartPlugin() {
	WinampMessage(WINAMP_VISPLUGIN);
}

void Geekamp::BangAmp_StopFade() {
	WinampMessage(WINAMP_BUTTON4_SHIFT);
}

void Geekamp::BangAmp_StopPlugin() {
	WinampMessage(WINAMP_VISPLUGIN);
}

void Geekamp::BangAmp_ToggleBrowser() {
	SetForegroundWindow(GetWinampWnd());
	WinampMessage(WINAMP_MINIBROWSER_TOGGLE);
}

void Geekamp::BangAmp_VisSetup() {
	SetForegroundWindow(GetWinampWnd());
	WinampMessage(WINAMP_VISSETUP);
}

void Geekamp::BangAmp_VolumeDown() {
	WinampMessage(WINAMP_VOLUMEDOWN);
}

void Geekamp::BangAmp_VolumeUp() {
	WinampMessage(WINAMP_VOLUMEUP);
}

void Geekamp::BangAmp_WindowShade() {
	WinampMessage(WINAMP_OPTIONS_WINDOWSHADE);
}

void Geekamp::BangAmp_Stop() {
	WinampMessage(WINAMP_STOP);
}

void Geekamp::BangAmp_Rew() {
	WinampMessage(WINAMP_REWIND);
}

void Geekamp::BangAmp_HighPriority() {
	WinampMessage(WINAMP_HIGH_PRIORITY);
}

void Geekamp::BangAmp_PowerOn() {
	(!GetWinampWnd()) ? WinampOpen() : SetForegroundWindow(GetWinampWnd());
}

void Geekamp::BangAmp_PowerOff() {
	WinampMessage(WINAMP_FILE_QUIT);
}

void Geekamp::BangAmp_LoadEQPreset() {
	SetForegroundWindow(GetWinampWnd());
	WinampMessage(IDM_EQ_LOADPRE);
}

void Geekamp::BangAmp_FileInfo() {
	// Getting the winamp title and removing the "-Winamp" from it
	GetWindowText(GetWinampWnd(), song_title, sizeof(song_title));
	p = song_title + strlen(song_title) - 8;
	while (p >= song_title) 
	{
		if (!strnicmp(p, "- Winamp", 8))
			break;
		p--;
	}
	if (p >= song_title)
		p--;
	while (p >= song_title && *p == ' ') 
		p--;
	*++p = 0;
	
	samplerate = SendMessage(GetWinampWnd(), WM_USER, 0, WINAMP_USER_BITRATE); // The samplerate of the current song
	bitrate = SendMessage(GetWinampWnd(), WM_USER, 1, WINAMP_USER_BITRATE); // The bitrate of the current song
	channels = SendMessage(GetWinampWnd(), WM_USER, 2, WINAMP_USER_BITRATE); // The channel status
	
	(channels == 1) ? strcpy(chan, "Mono") : strcpy(chan, "Stereo");
	sprintf(fileProp, "Bitrate: %d kbps\nSampleRate: %d khz\nChannels: %s", bitrate, samplerate, chan);
	MessageBox(GetLitestepWnd(), fileProp, song_title, MB_OK | MB_ICONQUESTION | MB_SETFOREGROUND);
}

void Geekamp::BangAmp_PlayPause() {
	if (!PlayPauseNotOpen) {
		if (!GetWinampWnd())
			WinampOpen();
	}
	int status = SendMessage(GetWinampWnd(), WM_USER, 0, WINAMP_USER_STATUS);
	(status == 1) ? WinampMessage(WINAMP_PAUSE) : WinampMessage(WINAMP_PLAY);
}

void Geekamp::BangAmp_Ffwd10s() {
	MovePositive(10);
}

void Geekamp::BangAmp_Ffwd20s() {
	MovePositive(20);
}

void Geekamp::BangAmp_Rew10s() {
	MoveNegative(10);
}

void Geekamp::BangAmp_Rew20s() {
	MoveNegative(20);
}

void Geekamp::BangAmp_Restart() {
	SendMessage(GetWinampWnd(), WM_USER, 0, WINAMP_USER_RESTART);
}

void Geekamp::BangAmp_MovePosition(LPCSTR args) {
	if (args) {
		char* tokens[1]; 
		char modifier[1]; // + or -
		char amount[10]; // amount to change by
		modifier[0] = amount[0] = 0; // nulling the first in the array
		
		tokens[0] = modifier;
		tokens[1] = amount;
		
		LCTokenize(args, tokens, 2, NULL);
		// if modifier is negative send to MoveNegative(), else MovePositive()
		(!strcmp(modifier, "-")) ? MoveNegative((int)amount) : MovePositive((int)amount);
	}
}

// These are the main processing functions...

// Moves position backwards
void Geekamp::MoveNegative(int amount) {
	amount *= 1000;
	position = SendMessage(GetWinampWnd(), WM_USER, 0, WINAMP_USER_SONGPOSITION);
	SendMessage(GetWinampWnd(), WM_USER, position - amount, WINAMP_USER_SONGSEEK);
}

// Moves position forwards
void Geekamp::MovePositive(int amount) {
	amount *= 1000;
	position = SendMessage(GetWinampWnd(), WM_USER, 0, WINAMP_USER_SONGPOSITION);
	SendMessage(GetWinampWnd(), WM_USER, position + amount, WINAMP_USER_SONGSEEK);
}

// This is our main message handler where all winamp message are passed to
void Geekamp::WinampMessage(const int messages) {
	SendMessage(GetWinampWnd(), WM_COMMAND, messages, 0);
}

// Our simple winamp opener checks to run in minimised or normal modes
void Geekamp::WinampOpen() {
	(WinampStartNormal) ? WinExec(szAmpPath, SW_NORMAL) : WinExec(szAmpPath, SW_MINIMIZE);
}

HWND Geekamp::GetWinampWnd() {
	return FindWindow("Winamp v1.x", NULL);
}

void Geekamp::BangAmp_LS2K() {
	sprintf(names, "@Jalist, @azathoth, @demigod, @CraHan, @NeXTer, @Gambit, @rootrider, @_why, @Claymore, @TNL, @negotive, @Mulvane, @galois, @dreamer, @DevilBoi, +Aja, +cravecave, +kuhndog, +Schmots, +la_haine, +Allout, +Eraser, +WareWolf, fiveiron, Aero, Sci, namaide, mademoiselle, PHisH, KaelinX, adosoda, mr_phat, cHIN^, Lozer, ldemon, Deft, `Prophet, noodge, qwilk, gear, jugg, tharris, therin, Vulpes, phake, mtp, blkhawk, Ego, ChromeTiger, empy, prion, Mountaineer, Cosmok\n\nCome down to #LS2k on EFNet, Undernet, Dalnet and irc.openprojects.net to join in the #LS2k gang.\n\nCheck http://www.ls2k.org/ regularly for updates.");
	MessageBox(GetWinampWnd(), names, "#LS2k Folk", 32);
}